/***************************************************************************/
/*                                                                         */
/*     Copyright (c) QUINN-CURTIS, Inc., 1992 - 1998                       */
/*                                                                         */
/***************************************************************************/
/**                                                                        */
/**   Filename :   hook.c                                                  */
/**   Author   :   QC                                                      */
/**   Revision :   3.0                                                    */
/**   Date     :   August 15, 1998                                        */
/**   Product  :   Windows Charting Tools                                  */
/**                                                                        */
/**   Description: Contains routines that can be modified by the user      */
/**                All the routines in the file must not be deleted.       */
/**                This file must be compiled and linked with the program. */                                   
/**                                                                        */
/**   Revisions  : 2/5/93 - "_export" was removed from EditObject def.     */
/**                3/18/93 - Keyboard message processing added.            */
/**                12/27/94  rev. 2.0 - 32-bit support                     */
/**                                                                        */
/***************************************************************************/
                                                                           
// #include "stdafx.h"      // uncomment for Visual C++

#ifdef _MSC_VER
#pragma warning( disable : 4103)
#endif


#include <windows.h>
#include "menus.h"
#include <windowsx.h>
#include "qcwin.h"
#include "burst.h"
#pragma hdrstop

#include "wx.h"

#include "support.h"
#include  "resource.h"

#pragma pack (push, 8)



/*************************************************************************
   Default object editing is done in DefEditObject. You can switch to
   your own editing functions for any object type here.

 *************************************************************************/

void CALLBACK EditObject (PGRAPH_DEF pGrDesc)
{
	HGOBJ  hObj;          // handle to selected object
	int    nObjType;      // object type
    int    ret;


	hObj = WGGetSelObject (pGrDesc, NULL, NULL);  // handle to selected object
	nObjType = WGGetObjectType (pGrDesc, hObj);   // determine object type
 
	switch (nObjType){
/*************************************************************************
 To intercept, for example, editing of legends with your own routine called
		UserEditLegends, enter the following: 

        case GO_LEGEND:
            UserEditLegends (pGrDesc, hObj);
            break;
**************************************************************************/
		default:
			ret = DefEditObject (pGrDesc);  // can be IDOK or IDCANCEL
	}
}
/**************************************************************************/
/* This routine is called when any mouse event occured while the mouse    */
/* cursor is over the Graph window                                        */
/**************************************************************************/
void WINAPI WGGraphMouseEvent (HWND hwnd, UINT message, POINT ptMouse)
{

 double rX, rY, rXn, rYn;
 DWORD index;

 switch (message) {
	case WM_LBUTTONDOWN:
		switch(fCountsMouse) {    // flag to indicate that user has requested cursors
		   case FIND_BACKGROUND:
			   if(WGGetMousePos(cd.pGraph,  cd.hAxisX, cd.hAxisY, &rX, &rY)) {
		          WGGetNearestPoint(cd.pGraph, rX, rY, FNP_X, &rXn, &rYn, NULL, &index);   
	              WGMoveDataCursor (cd.pGraph, cd.hCur1, rXn, rYn, TRUE);
			      cd.cur1 = index; 
		          DisplayBkGrdValue(cd.cur1, cd.cur2);
			   }
			   break;
		
		  case SET_AC_LIMIT :
			  if(WGGetMousePos(cd.pGraph,  cd.hAxisX, cd.hAxisY, &rX, &rY)) {
		          WGGetNearestPoint(cd.pGraph, rX, rY, FNP_X, &rXn, &rYn, NULL, &index);   
	              WGMoveDataCursor (cd.pGraph, cd.hCur1, rXn, rYn, TRUE);  
		          cd.cur1 = index; 
			      SaveACLimits(cd.cur1, cd.cur2);
			  }
		      break;
		 
		 default: 
		      ObjFind (hwnd);  // default operation - find and highlight object
		 }
		 break;

	case WM_LBUTTONDBLCLK:   // default operation - edit selected object.
		  WGEditObject (hwnd); // Can be replaced by user own actions
		  break;

	case WM_MOUSEMOVE:       // call your routines, if you want
        //  WGShowMouseCoord (hwnd, CO_PHYS, FALSE);
		  break;

	case WM_RBUTTONDOWN:   // cursor 2
		switch(fCountsMouse) {
		   case FIND_BACKGROUND:
			   if(WGGetMousePos(cd.pGraph,  cd.hAxisX, cd.hAxisY, &rX, &rY)) {
		          WGGetNearestPoint(cd.pGraph, rX, rY, FNP_X, &rXn, &rYn, NULL, &index);   
	              WGMoveDataCursor (cd.pGraph, cd.hCur2, rXn, rYn, TRUE);
			      cd.cur2 = index; 
		          DisplayBkGrdValue(cd.cur1, cd.cur2);
			   }
			   break;
		
		  case SET_AC_LIMIT :
			  if(WGGetMousePos(cd.pGraph,  cd.hAxisX, cd.hAxisY, &rX, &rY)) {
		          WGGetNearestPoint(cd.pGraph, rX, rY, FNP_X, &rXn, &rYn, NULL, &index);   
	              WGMoveDataCursor (cd.pGraph, cd.hCur2, rXn, rYn, TRUE);  
		          cd.cur2 = index; 
			      SaveACLimits(cd.cur1, cd.cur2);
			  }
		      break;
		  
		  default: 
		   ObjFind (hwnd);  // default operation - find and highlight object
		}
		break;
		


	case WM_RBUTTONDBLCLK:
           WGShowMouseCoord (hwnd, CO_PHYS, TRUE);
           break;
    }

}

/*************************************************************************/
/* This routine is called when a WM_CHAR message is received by the      */
/* Graph window hwnd that has the focus.                                 */
/*************************************************************************/

void WINAPI WGGraphKeyEvent (HWND hwnd,   // graph window handle
    UINT message,                    // WM_KEYUP, WM_KEYDOWN or WM_CHAR
    WPARAM nVKey,                    // virtual key-code value of the key
    LPARAM dwKeyData)                // value of lParam of WM_CHAR
{
    // Put your key processing here
	switch (message)
    {
        case WM_KEYUP:
            break;

        case WM_KEYDOWN:
            break;

        case WM_CHAR:
            break;
    }
}

/*************************************************************************/
/* User extension for page window message processing                     */
/*************************************************************************/
LRESULT CALLBACK WGUserPageProc (HWND hwnd, UINT message,
        WPARAM wParam, LPARAM lParam)
{
	PPAGE_DEF  pPageDesc;
	PGRAPH_DEF pGrDesc;
	HMENU     hMenu, hSubMenu;
	char      szBuf[256];
	BOOL      result = FALSE;
    char      szFilter[] = "Tab delimited Data Files (*.txt)\0*.txt\0";
	char      szFilename[256];
	

  	switch (message)	{
		/* the following section causes graph selector buttons to appear
		   in the upper right corner of the page. If you do not want
		   that to happen, simply remove WM_CREATE message processing below.
		*/
		case WM_CREATE:
			{
				DWORD  dwStyle = GetWindowLong (hwnd, GWL_STYLE);
				
				WGSetPrintOrient(ORIENT_LANDSCAPE);	
				if (!(dwStyle & WS_CHILD))		{
					pPageDesc = WGGetPageDesc (hwnd);
					hMenu = GetMenu (hwnd);  					 // initialize menu
					if (hMenu != NULL)	{
					    hSubMenu = GetSubMenu (GetMenu (hwnd), IDM_OPTIONSPOS);
        				// turn on graph selection buttons
						WGToggleSelectors (pPageDesc, TRUE);
						CheckMenuItem (hSubMenu, IDM_SHOWSEL, MF_CHECKED);
					}
				}
			}
		    return 0;

        case WM_COMMAND: /* message: command from application menu */
    		{
        	    WORD    id = GET_WM_COMMAND_ID(wParam, lParam);

				pPageDesc = WGGetPageDesc (hwnd);
				switch (id)	{
				    case IDM_SAVEPCHDATA:
           		         strcpy(szFilename,pch.szFilename);
						 strcat(szFilename, "_PCH.txt");
						 strcpy(szBuf, GetSaveFile(hwnd, szFilename, szFilter , "txt"));
     					 if(szBuf[0] != '\0') SavePCHHist(szBuf, &pch) ;
						 break;
								     
					case IDM_CLOSEPCHPLOT:
						 FreePCHMemory(&pch);
						 SendMessage(hwnd,WM_CLOSE, 0,0);
						 break;
		 
					case IDM_SHOWDATA:
						 pGrDesc = WGGetGraphInPage(pPageDesc, 0); 
						 WGSetDataFormat (pGrDesc, hPCHPlot, 9, 6);
						 WGShowData (pGrDesc,  hPCHPlot);
						 break;
					case IDM_AUTOSAVE: break;

					case IDM_PRINTER_SETUP :     // set up default printer
					 	 WGPrinterSetup (hwnd);
						 break;
		
					case IDM_PRINTER_PAGE :    // print page with all its graphs
						 result = WGPrintPage(pPageDesc);
						 break;

					case IDM_PRINTER_PARAM : // call dialog box to modify print parameters
					 	 WGPrintOptionsDlg ();
					 	 break;

                    case IDM_PARGRAPH:  // call graph parameters dialog box
                         WGEditGraphDlg (pPageDesc);
                         break;

                    case IDM_CLEAR:      // delete selected graph
                         WGToggleSelectors (pPageDesc, FALSE);
                         WGDeleteGraph (WGGetSelectedGraph (pPageDesc));
                         WGToggleSelectors (pPageDesc, TRUE);
                         break;

                    case IDM_SHOWSEL:       // show graph selectors
                          WGToggleSelectors (pPageDesc,
                          WGMenuCheck (pPageDesc, id, IDM_OPTIONSPOS));
                          break;

                    case IDM_HIGHSEL:       // highlight selected graph
                          WGToggleHigh (pPageDesc, 
                          WGMenuCheck (pPageDesc, id, IDM_OPTIONSPOS));
                          break;

                     default:
                    break;
                }
            }
            return 0;
    }
    return (DefWindowProc(hwnd, message, wParam, lParam));
}

/*******************************************************************************************************************
  Turns off background cursors used to find selected indices of counts data
 ******************************************************************************************************************/
void TurnOffBackGroundSelect(HWND hwnd)
{
  CheckMenuItem(GetMenu(hwnd), IDM_SELECTBACKGROUND, MF_UNCHECKED);
  if(fCountsMouse == FIND_BACKGROUND) fCountsMouse = FALL_THROUGH;
  WGMoveDataCursor (cd.pGraph, cd.hCur1, 0, 0, FALSE);
  WGMoveDataCursor (cd.pGraph, cd.hCur2, 0, 0, FALSE);
}

/*******************************************************************************************************************
  Turns off segment select cursors used to find selected indices of counts data
 ******************************************************************************************************************/
void TurnOffFCSSegmentSelect(HWND hwnd)
{
  PHOTON_STREAM *ps = GETPS(active_ps);

  CheckMenuItem(GetMenu(hwnd), IDC_SELECT_AC_REGION, MF_UNCHECKED);
  if(fCountsMouse == SET_AC_LIMIT) fCountsMouse = FALL_THROUGH;
  WGMoveDataCursor (cd.pGraph, cd.hCur1, 0, 0, FALSE);
  WGMoveDataCursor (cd.pGraph, cd.hCur2, 0, 0, FALSE);
  ps->ACindex1 = 0;
  ps->ACindex2 = ps->nbins -1; 

}

/*******************************************************************************************************************
  Returns the index closest to passed value -- used to find array index nearest the cursor position
 ******************************************************************************************************************/
DWORD GetCurIndex(double *x, double value, DWORD n, DWORD default_ret)
{
 DWORD i;
 
 for(i=1;i<n;i++) if((value >= x[i-1]) && (value <= x[i])) return(i);
 return(default_ret);
}

/*******************************************************************************************************************
  Displays the background value in the edit box and text window, and saves value to active data set
 ******************************************************************************************************************/
void DisplayBkGrdValue(DWORD x1, DWORD x2)
{
 char szBuf[128];
 int temp; 
 PHOTON_STREAM *ps = GETPS(active_ps); 
 
 if(x2 < x1) { temp = x1; x1 = x2; x2 = temp; }
 ps->Bkg1 = (cd.SegNum * cd.BinsPerSegPt * (DWORD) cd.n) + (x1 * cd.BinsPerSegPt);  // index of ps->counts
 ps->Bkg2 = (cd.SegNum * cd.BinsPerSegPt * (DWORD) cd.n) + (x2 * cd.BinsPerSegPt);  // index of ps->counts
	
 CalcPSBkg(ps);
 init.BackGrdCounts = (DWORD) ps->BkMean; 
 wsprintf(szBuf,"%u", init.BackGrdCounts);
 SendDlgItemMessage(hPSControls,IDC_BACKGRDCOUNTS, WM_SETTEXT,sizeof(szBuf),(LPARAM)((LPSTR) szBuf));
 UpDateText(GETPS(active_ps), GETBURST(active_ps));
 
}

/*******************************************************************************************************************
  Saves index limits value to active data set
 ******************************************************************************************************************/
void SaveACLimits(DWORD x1, DWORD x2)
{
 DWORD temp; 
 PHOTON_STREAM *ps = GETPS(active_ps); 

				// calculate index of ps->counts
 if(x2 < x1) { temp = x1; x1 = x2; x2 = temp; }
 ps->ACindex1 = (cd.SegNum * cd.BinsPerSegPt * (DWORD) cd.n) + (x1 * cd.BinsPerSegPt); 
 ps->ACindex2 = (cd.SegNum * cd.BinsPerSegPt * (DWORD) cd.n) + (x2 * cd.BinsPerSegPt); 
}


/****************************************************************************************
  Calculates the mean and sd - max value of end must be 1 less then the array size
  ****************************************************************************************/
 void CalcPSBkg(PHOTON_STREAM *ps)
{
 DWORD i, n, end, start;
 double mean, sd;
 
 start = ps->Bkg1;
 end = ps->Bkg2;

 n = end - start + 1;  
 mean = sd = 0.0;
 
 for(i=start;i<=end;i++) mean += (double) ps->counts[i];
 mean /= (double) n;
 for(i=start;i<=end;i++) sd += (mean - (double) ps->counts[i]) * (mean - (double) ps->counts[i]);
 sd /= (double) (n);
 sd = sqrt(sd);
 ps->BkMean = mean;
 ps->BkSD = sd;
}


#pragma pack (pop)
